package addbk.JAddressBook;

import gui.ClosableJFrame;
import gui.run.RunTextField;

import java.awt.*;
import java.awt.event.TextEvent;

public class AddressBookJFrame
        extends ClosableJFrame {

    private boolean indexToggle = false;

    private boolean runOnce = false;

    private AddressJPanel ap =
            new AddressJPanel();
    private dialPhoneNavigationJPanel tbp =
            new dialPhoneNavigationJPanel();
    private RunTextField tf =
            new RunTextField("Name Field") {
                public void run() {
                    AddressBookJFrame.this.textValueChanged(null);

                }
            };
    private IndexJPanel ip =
            new IndexJPanel();
    private EditJPanel ep =
            new EditJPanel();


    public AddressBookJFrame() {
        Container c = getContentPane();
        c.setLayout(new BorderLayout());
        c.add(tf, "North");
        c.add(ap, "Center");
        c.add(tbp, "South");
        c.add(ip, "East");
        if (!indexToggle) remove(ip);

        if (!runOnce) { // to protect any resizing
            setSize(400, 400);
            setEditable(false);
        }
        setVisible(true);
        runOnce = true;
        AddressBookRecord emptyDbRecord = AddressBookRecord.getEmptyDbRecord();
        setRecord(emptyDbRecord);

    }

    public void setRecord(AddressBookRecord abr) {
        getTf().setText(abr.getName());
        AddressJPanel ap = getAp();
        ap.t0.setText(abr.getAddress());
        ap.t1.setText(abr.getNotes());
        dialPhoneNavigationJPanel tbp = getTbp();
        tbp.tfp.t0.setText(abr.getDial1());
        tbp.tfp.t1.setText(abr.getDial2());
        tbp.tfp.t2.setText(abr.getDial3());
        PhoneNumberJPanel tfp = getEditPanel().tfp;
        tfp.t0.setText(abr.getDial1());
        tfp.t1.setText(abr.getDial2());
        tfp.t2.setText(abr.getDial3());
    }

    public void textValueChanged(TextEvent e) {
        AddressBookMediator abm =
                AddressBookMediator.getAddressBookMediator();
        abm.setEditFlag(true);
    }

    public boolean isIndexToggle() {
        return indexToggle;
    }

    public void setIndexToggle(boolean indexToggle) {
        this.indexToggle =
                indexToggle;
    }

    public boolean isRunOnce() {
        return runOnce;
    }

    public void setRunOnce(boolean runOnce) {
        this.runOnce = runOnce;
    }

    public AddressJPanel getAp() {
        return ap;
    }

    public void setAp(AddressJPanel ap) {
        this.ap = ap;
    }

    public dialPhoneNavigationJPanel getTbp() {
        return tbp;
    }


    public RunTextField getTf() {
        return tf;
    }

    public IndexJPanel getIndexPanel() {
        return ip;
    }


    public EditJPanel getEditPanel() {
        return ep;
    }


    public AddressBookRecord getAddressBookRecord() {
        AddressBookRecord abr =
                new AddressBookRecord();

        abr.setName(getTf().getText());
        abr.setAddress(getAp().t0.getText());
        abr.setNotes(getAp().t1.getText());

        abr.setDial1(getTbp().tfp.t0.getText());
        abr.setDial2(getTbp().tfp.t1.getText());
        abr.setDial3(getTbp().tfp.t2.getText());
        return abr;
    }

    public void setEditable(boolean b) {
        ap.setEditable(b);
        tbp.setEditable(b);
        Container c = getContentPane();
        c.setLayout(new BorderLayout());
        c.add(tf, "North");
        c.add(ap, "Center");
        c.add(tbp, "South");
        c.add(ip, "East");
        if (!indexToggle) remove(ip);

        if (!runOnce) { // to protect any resizing
            setSize(400, 400);
            tf.setEditable(false);
            ap.t0.setEditable(false);
            ap.t1.setEditable(false);
        }
        setVisible(true);
        runOnce = true;
        setRecord(AddressBookRecord.getEmptyDbRecord());
    }
}
