package addbk.JAddressBook;


/**
 * Created by IntelliJ IDEA.
 * User: Subhash
 * Date: Mar 16, 2005
 * Time: 7:37:33 AM
 * To change this template use File | Settings | File Templates.
 */

public final class AddressBookMediator {
    private static AddressBookMediator abm = new AddressBookMediator();

    private AddressBookRecord storageRecord = new AddressBookRecord();
    private boolean editFlag = false;
    private boolean emptyDb = true;

    private AddressBookJFrame adf = null;
    private AddressBookDatabase abd = null;


    // todo add singleton pattern!
    private AddressBookMediator() {
        adf = new  AddressBookJFrame();
        abd = new AddressBookDatabase();
    }

    public static AddressBookMediator getAddressBookMediator() {
        return abm;
    }

    public void nextRecord() {
        getAbd().incrementRecord();
        setStorageRecord((getAbd().readRecord()));
        adf.setRecord(getAbd().readRecord());
    }

    public void prevRecord() {
        getAbd().decrementRecord();
        setStorageRecord((getAbd().readRecord()));
        adf.setRecord(getAbd().readRecord());
    }

    public void addRecord() {
        AddressBookMediator abm = AddressBookMediator.getAddressBookMediator();
        AddressBookRecord abr = abm.getAddressBookFrame().getAddressBookRecord();
        getAbd().addRecord(abr);
        setStorageRecord((getAbd().readRecord()));
        IndexJPanel indexPanel = getAdf().getIndexPanel();
        indexPanel.add(abr.getName());
        getAddressBookMediator().setIndexItems();
        setEditFlag(false);
    }

    public void deleteCurrentRecord() {
        getAbd().deleteCurrentRecord();
        getAddressBookMediator().setIndexItems();
        setEditFlag(false);
        setStorageRecord((getAbd().readRecord()));
    }

    public void revertRecord() {
        getAbd().saveCurrentRecord(getStorageRecord());
        setStorageRecord((getAbd().readRecord()));
        adf.setRecord(getAbd().readRecord());
        setEditFlag(false);
    }


    public void toggleIndexDisplay() {
        // todo display index here
        System.out.println("to be implemented");
    }

    public void setIndexItems() {
        getAdf().getIndexPanel().indexList.removeAll();
        for (int i = 0; i <
                (getAbd().getNumRecords()); i++) {
            AddressBookRecord abr = getAbd()
                    .readRecord(i);
            getAdf().getIndexPanel().indexList.add(abr.getName());
        } // end for
    }

    public void setRecord(int i) {
        getAbd().setRecordNumber(i);
        AddressBookRecord abr = getAbd()
                .readRecord();
        adf.setRecord(abr);
        setStorageRecord((getAbd().readRecord()));
    }


    public void dbMerge() {
        new CSVMerge(getAbd());
        getAbd().sort();
        getAddressBookMediator().setRecord(0);
        getAddressBookMediator().setIndexItems();
        setEmptyDb(false);
    }

    public void dbExport() {
        new CSVExport(getAbd());
    }

    public void dbOpen() {
        getAbd().openDb();
        adf.setRecord(getAbd().readRecord());
        getAddressBookMediator().setRecord(0);
        getAddressBookMediator().setIndexItems();
        setEmptyDb(false);
    }

    public void dbSave() {
        getAbd().saveDb();
    }

    public AddressBookRecord getStorageRecord() {
        return storageRecord;
    }

    public void setStorageRecord(AddressBookRecord storageRecord) {
        this.storageRecord =
                storageRecord;
    }

    public boolean isEditFlag() {
        return editFlag;
    }

    public void setEditFlag(boolean editFlag) {
        this.editFlag = editFlag;
    }

    public boolean isEmptyDb() {
        return emptyDb;
    }

    public void setEmptyDb(boolean emptyDb) {
        this.emptyDb = emptyDb;
    }

    public AddressBookJFrame getAdf() {
        return adf;
    }

    public void setAdf(AddressBookJFrame adf) {
        this.adf = adf;
    }

    public AddressBookDatabase getAbd() {
        return abd;
    }

    public void setAbd(AddressBookDatabase abd) {
        if (abd == null) return;
        this.abd = abd;
    }


    public AddressBookJFrame getAddressBookFrame() {
        return adf;
    }


}
